unit main;

interface

uses
  Forms, Classes, MFBaseComponent, MFCustomTransport, MFBluetooth,
  Controls, StdCtrls;

type
  TfmMain = class(TForm)
    MFBluetooth1: TMFBluetooth;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Button7: TButton;
    procedure MFBluetooth1Connect(Sender: TMFCustomConnection);
    procedure MFBluetooth1Disconnect(Sender: TMFCustomConnection);
    procedure MFBluetooth1Read(Sender: TMFCustomConnection; const Buf: TMFByteArray);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  end;

var
  fmMain: TfmMain = nil;

implementation

uses
  SysUtils, Dialogs;

{$R *.dfm}

procedure TfmMain.MFBluetooth1Connect(Sender: TMFCustomConnection);
begin
  Memo1.Lines.Add('Connect');
  Memo1.Lines.Add('  local address: ' + Sender.LocalAddress);
  Memo1.Lines.Add('  local name: ' + Sender.LocalName);
  Memo1.Lines.Add('  remote address: ' + Sender.RemoteAddress);
  Memo1.Lines.Add('  remote name: ' + Sender.RemoteName);
end;

procedure TfmMain.MFBluetooth1Disconnect(Sender: TMFCustomConnection);
begin
  Memo1.Lines.Add('Disconnect');
  Memo1.Lines.Add('  local address: ' + Sender.LocalAddress);
  Memo1.Lines.Add('  local name: ' + Sender.LocalName);
  Memo1.Lines.Add('  remote address: ' + Sender.RemoteAddress);
  Memo1.Lines.Add('  remote name: ' + Sender.RemoteName);
end;

procedure TfmMain.MFBluetooth1Read(Sender: TMFCustomConnection; const Buf: TMFByteArray);
var
  Str: string;
  Loop: Integer;
  Ans: TMFByteArray;
begin
  Memo1.Lines.Add('Data: ');
  Memo1.Lines.Add('  local address: ' + Sender.LocalAddress);
  Memo1.Lines.Add('  local name: ' + Sender.LocalName);
  Memo1.Lines.Add('  remote address: ' + Sender.RemoteAddress);
  Memo1.Lines.Add('  remote name: ' + Sender.RemoteName);
  Str := ' ';
  for Loop := 0 to Length(Buf) - 1 do Str := Str + ' $' + IntToHex(Buf[Loop], 2);
  Memo1.Lines.Add(Str);
  SetLength(Ans, 7);
  if Buf[0] = $80 then begin
    Ans[0] := $A0;
    Ans[1] := $00;
    Ans[2] := $07;
    Ans[3] := $10;
    Ans[4] := $00;
    Ans[5] := $00;
    Ans[6] := $FF;
    Sender.Write(Ans);
  end else begin
    SetLength(Ans, 3);
    Ans[0] := $90;
    Ans[1] := $00;
    Ans[2] := $03;
    Sender.Write(Ans);
  end;
end;

procedure TfmMain.Button1Click(Sender: TObject);
begin
  MFBluetooth1.Listen;
  Memo1.Lines.Add('Listen');
  Memo1.Lines.Add('  local address: ' + MFBluetooth1.LocalAddress);
  Memo1.Lines.Add('  local name: ' + MFBluetooth1.LocalName);
end;

procedure TfmMain.Button2Click(Sender: TObject);
begin
  MFBluetooth1.Address := Edit1.Text;
  MFBluetooth1.Connect;
end;

procedure TfmMain.Button3Click(Sender: TObject);
begin
  MFBluetooth1.Close;
  Memo1.Lines.Add('Close');
end;

procedure TfmMain.Button4Click(Sender: TObject);
var
  Ans: TMFByteArray;
begin
  SetLength(Ans, 7);
  Ans[0] := $80;
  Ans[1] := $00;
  Ans[2] := $07;
  Ans[3] := $10;
  Ans[4] := $00;
  Ans[5] := $00;
  Ans[6] := $FF;
  MFBluetooth1.Connections[0].Write(Ans);
end;

procedure TfmMain.Button5Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

procedure TfmMain.Button6Click(Sender: TObject);
begin
  MFBluetooth1.Connections[0].Close;
end;

procedure TfmMain.Button7Click(Sender: TObject);
begin
  Edit1. Text := MFBluetooth1.SelectDevice;
end;

end.
